(function($) {
	"use strict";

	class Fx1 {
		DOM = {
			el: null,
			bottom: null,
			top: null
		}
		constructor(DOM_el) {
			this.DOM.el = DOM_el;
			this.layout();
		}
		layout() {			
		
			// get element background-image url
			const url = getComputedStyle(this.DOM.el).backgroundImage.match(/url\(["']?([^"']*)["']?\)/)[1];
			gsap.set(this.DOM.el, {backgroundImage: 'none'});

			const iterations = 2;
			let innerHTML = '';
			for (let i = 0; i < iterations; ++i) {
				innerHTML += `<div class="double__img" style="background-image:url(${url})"></div>`;
			}
			this.DOM.el.innerHTML = innerHTML;

			this.DOM.bottom = this.DOM.el.querySelector('.double__img:first-child');
			this.DOM.top = this.DOM.el.querySelector('.double__img:last-child');
			
			gsap.set(this.DOM.bottom, {
				scale: 1.15
			});
		}
		mouseenter() {

			if ( this.leaveTimeout ) {
				this.leaveTimeout.kill();
			}

			this.enterTimeout = gsap.timeline({
				defaults: {
					duration: 0.7,
					ease: 'power3.inOut',
				},
			})
			.set(this.DOM.bottom, {willChange: 'filter'})
			.set(this.DOM.top, {willChange: 'clip-path'})
			.fromTo(this.DOM.top, {
				clipPath: 'polygon(0% 0%, 100% 0%, 100% 100%, 0% 100%)',
			}, {
				clipPath: 'polygon(0% 0%, 0% 0%, 0% 100%, 0% 100%)'
			}, 0)
			
			.fromTo(this.DOM.bottom, {
				filter: 'brightness(400%) saturate(200%) hue-rotate(190deg)',
			}, {
				filter: 'brightness(100%) saturate(100%) hue-rotate(0deg)',
			}, 0)

		}
		mouseleave() {
			
			if ( this.enterTimeout ) {
				this.enterTimeout.kill();
			}

			this.leaveTimeout = gsap.timeline({
				defaults: {
					duration: 0.7,
					ease: 'power3.inOut',
				},
			})
			.set(this.DOM.bottom, {willChange: 'filter'})
			.set(this.DOM.top, {willChange: 'clip-path'})
			.to(this.DOM.top, {
				clipPath: 'polygon(0% 0%, 100% 0%, 100% 100%, 0% 100%)'
			}, 0)

			.to(this.DOM.bottom, {
				filter: 'brightness(400%) saturate(200%) hue-rotate(190deg)',
			}, 0)

		}
	}

	class Fx2 {
		DOM = {
			el: null
		}
		constructor(DOM_el) {
			this.DOM.el = DOM_el;
			this.layout();
		}
		layout() {
			
			// get element background-image url
			const url = getComputedStyle(this.DOM.el).backgroundImage.match(/url\(["']?([^"']*)["']?\)/)[1];
			gsap.set(this.DOM.el, {backgroundImage: 'none'});

			const iterations = 2;
			let innerHTML = '';
			for (let i = 0; i < iterations; ++i) {
				innerHTML += `<div class="double__img" style="background-image:url(${url})"></div>`;
			}
			this.DOM.el.innerHTML = innerHTML;

			this.DOM.bottom = this.DOM.el.querySelector('.double__img:first-child');
			this.DOM.top = this.DOM.el.querySelector('.double__img:last-child');
		}
		mouseenter() {

			if ( this.leaveTimeout ) {
				this.leaveTimeout.kill();
			}

			this.enterTimeout = gsap.timeline({
				defaults: {
					duration: 0.6,
					ease: 'power3',
				},
			})
			.set(this.DOM.top, {willChange: 'clip-path'})
			.fromTo(this.DOM.top, {
				clipPath: 'polygon(0% 0%, 100% 0%, 100% 100%, 0% 100%)',
			}, {
				clipPath: 'polygon(100% 0%, 100% 0%, 100% 100%, 100% 100%)'
			}, 0)
			
			.fromTo(this.DOM.bottom, {
				scale: 1,
				filter: 'brightness(400%) hue-rotate(-190deg)',
			}, {
				scale: 1.3,
				filter: 'brightness(100%) hue-rotate(0deg)'
			}, 0);

		}
		mouseleave() {
			
			if ( this.enterTimeout ) {
				this.enterTimeout.kill();
			}

			this.leaveTimeout = gsap.timeline({
				defaults: {
					duration: 0.6,
					ease: 'power3.inOut',
				},
			})
			.set(this.DOM.top, {willChange: 'clip-path'})
			.to(this.DOM.top, {
				clipPath: 'polygon(0% 0%, 100% 0%, 100% 100%, 0% 100%)'
			}, 0)

		}
	}

	class Fx3 {
		DOM = {
			el: null
		}
		constructor(DOM_el) {
			this.DOM.el = DOM_el;
			this.layout();
		}
		layout() {

			// get element background-image url
			const url = getComputedStyle(this.DOM.el).backgroundImage.match(/url\(["']?([^"']*)["']?\)/)[1];
			gsap.set(this.DOM.el, {backgroundImage: 'none'});

			const iterations = 2;
			let innerHTML = '';
			for (let i = 0; i < iterations; ++i) {
				innerHTML += `<div class="double__img" style="background-image:url(${url})"></div>`;
			}
			this.DOM.el.innerHTML = innerHTML;

			this.DOM.bottom = this.DOM.el.querySelector('.double__img:first-child');
			this.DOM.top = this.DOM.el.querySelector('.double__img:last-child');
			
			gsap.set(this.DOM.bottom, {
				scaleX: -0.97,
				scaleY: 0.97,
				filter: 'saturate(200%)'
			});
		}
		mouseenter() {

			if ( this.leaveTimeout ) {
				this.leaveTimeout.kill();
			}

			this.enterTimeout = gsap.timeline({
				defaults: {
					duration: 0.8,
					ease: "steps(6)",
				},
			})
			.set(this.DOM.top, {willChange: 'clip-path'})
			.fromTo(this.DOM.top, {
				clipPath: 'polygon(0% 0%, 100% 0%, 100% 100%, 0% 100%)',
			}, {
				clipPath: 'polygon(0% 100%, 100% 100%, 100% 100%, 0% 100%)'
			}, 0)

		}
		mouseleave() {
			
			if ( this.enterTimeout ) {
				this.enterTimeout.kill();
			}

			this.leaveTimeout = gsap.timeline({
				defaults: {
					duration: 0.8,
					ease: "steps(6)",
				},
			})
			.set(this.DOM.top, {willChange: 'clip-path'})
			.to(this.DOM.top, {
				clipPath: 'polygon(0% 0%, 100% 0%, 100% 100%, 0% 100%)'
			}, 0)


		}
	}
	
	class Fx4 {
		DOM = {
			el: null
		}
		constructor(DOM_el) {
			this.DOM.el = DOM_el;
			this.layout();
		}
		layout() {
			
			// get element background-image url
			const url = getComputedStyle(this.DOM.el).backgroundImage.match(/url\(["']?([^"']*)["']?\)/)[1];
			gsap.set(this.DOM.el, {backgroundImage: 'none'});

			const iterations = 3;
			let innerHTML = '';
			for (let i = 0; i < iterations; ++i) {
				innerHTML += `<div class="double__img" style="background-image:url(${url})"></div>`;
			}
			this.DOM.el.innerHTML = innerHTML;

			this.DOM.bottom = this.DOM.el.querySelector('.double__img:first-child');
			this.DOM.middle = this.DOM.el.querySelector('.double__img:nth-child(2)');
			this.DOM.top = this.DOM.el.querySelector('.double__img:last-child');
			
			gsap.set(this.DOM.middle, {
				scale: 0.97,
				filter: 'saturate(400%) blur(5px)'
			});

			gsap.set(this.DOM.bottom, {
				scale: 0.94
			});
		}
		mouseenter() {

			if ( this.leaveTimeout ) {
				this.leaveTimeout.kill();
			}
			const DURATION = 0.25;
			this.enterTimeout = gsap.timeline({
				defaults: {
					duration: 0.8,
					ease: "none",
				},
			})
			.addLabel('start', 0)
			.set([this.DOM.top, this.DOM.middle], {willChange: 'clip-path'})
			.fromTo(this.DOM.top, {
				clipPath: 'polygon(0% 0%, 100% 0%, 100% 100%, 0% 100%)',
			}, {
				clipPath: 'polygon(0% 0%, 100% 0%, 100% 0%, 0% 0%)'
			}, 'start')
			.fromTo(this.DOM.middle, {
				xPercent: 0
			}, {
				duration: DURATION,
				ease: 'elastic.inOut(5)',
				xPercent: -3,
				repeat: 1
			}, 'start')
			.fromTo(this.DOM.middle, {
				clipPath: 'polygon(0% 0%, 100% 0%, 100% 100%, 0% 100%)',
			}, {
				clipPath: 'polygon(0% 0%, 100% 0%, 100% 0%, 0% 0%)'
			}, `start+=${DURATION*0.7}`)
			.fromTo(this.DOM.bottom, {
				xPercent: 0,
				yPercent: 0,
			}, {
				duration: DURATION,
				ease: 'elastic.inOut(5)',
				xPercent: 1,
				yPercent: -1,
				repeat: 1
			}, `start+=${DURATION*0.7}`)

		}
		mouseleave() {
			
			if ( this.enterTimeout ) {
				this.enterTimeout.kill();
			}

			this.leaveTimeout = gsap.timeline({
				defaults: {
					duration: 0.4,
					ease: "none",
				},
			})
			.set(this.DOM.top, {willChange: 'clip-path'})
			.to(this.DOM.top, {
				clipPath: 'polygon(0% 0%, 100% 0%, 100% 100%, 0% 100%)'
			}, 0)

		}
	}
	
	class Fx5 {
		DOM = {
			el: null,
			bottom: null,
			top: null
		}
		constructor(DOM_el) {
			this.DOM.el = DOM_el;
			this.layout();
		}
		layout() {
			
			// get element background-image url
			const url = getComputedStyle(this.DOM.el).backgroundImage.match(/url\(["']?([^"']*)["']?\)/)[1];
			gsap.set(this.DOM.el, {backgroundImage: 'none'});

			const iterations = 2;
			let innerHTML = '';
			for (let i = 0; i < iterations; ++i) {
				innerHTML += `<div class="double__img" style="background-image:url(${url})"></div>`;
			}
			this.DOM.el.innerHTML = innerHTML;

			this.DOM.bottom = this.DOM.el.querySelector('.double__img:first-child');
			this.DOM.top = this.DOM.el.querySelector('.double__img:last-child');
		}
		mouseenter() {

			if ( this.leaveTimeout ) {
				this.leaveTimeout.kill();
			}

			this.enterTimeout = gsap.timeline({
				defaults: {
					duration: 0.5,
					ease: 'power2',
				},
			})
			.set(this.DOM.bottom, {willChange: 'filter'})
			.set(this.DOM.top, {willChange: 'clip-path'})
			.fromTo(this.DOM.top, {
				clipPath: 'circle(70.7% at 50% 50%)',
			}, {
				clipPath: 'circle(0% at 50% 50%)'
			}, 0)
			
			.fromTo(this.DOM.bottom, {
				scale: 1.5,
				filter: 'brightness(400%) saturate(200%) hue-rotate(190deg)',
			}, {
				scale: 1.3,
				filter: 'brightness(100%) saturate(100%) hue-rotate(0deg)',
			}, 0)

		}
		mouseleave() {
			
			if ( this.enterTimeout ) {
				this.enterTimeout.kill();
			}

			this.leaveTimeout = gsap.timeline({
				defaults: {
					duration: 0.5,
					ease: 'power2.inOut',
				},
			})
			.set(this.DOM.bottom, {willChange: 'filter'})
			.set(this.DOM.top, {willChange: 'clip-path'})
			.to(this.DOM.top, {
				clipPath: 'circle(70.7% at 50% 50%)'
			}, 0)

			.to(this.DOM.bottom, {
				scale: 1.5,
				filter: 'brightness(400%) saturate(200%) hue-rotate(190deg)',
			}, 0)

		}
	}
	
	class Fx6 {
		DOM = {
			el: null,
			bottom: null,
			top: null
		}
		constructor(DOM_el) {
			this.DOM.el = DOM_el;
			this.layout();
		}
		layout() {
			
			// get element background-image url
			const url = getComputedStyle(this.DOM.el).backgroundImage.match(/url\(["']?([^"']*)["']?\)/)[1];
			gsap.set(this.DOM.el, {backgroundImage: 'none'});

			const iterations = 2;
			let innerHTML = '';
			for (let i = 0; i < iterations; ++i) {
				innerHTML += `<div class="double__img" style="background-image:url(${url})"></div>`;
			}
			this.DOM.el.innerHTML = innerHTML;

			this.DOM.bottom = this.DOM.el.querySelector('.double__img:first-child');
			this.DOM.top = this.DOM.el.querySelector('.double__img:last-child');
			
			/*
			gsap.set(this.DOM.bottom, {
				scale: 1.4
			});
			*/
		}
		mouseenter() {

			if ( this.leaveTimeout ) {
				this.leaveTimeout.kill();
			}

			this.enterTimeout = gsap.timeline({
				defaults: {
					duration: 0.9,
					ease: 'expo',
				},
			})
			.set(this.DOM.bottom, {willChange: 'filter'})
			.set(this.DOM.top, {willChange: 'clip-path'})
			.fromTo(this.DOM.top, {
				clipPath: 'circle(70.7% at 50% 50%)',
			}, {
				clipPath: 'circle(0% at 50% 50%)'
			}, 0)
			
			.fromTo(this.DOM.bottom, {
				scale: 1,
				filter: 'brightness(80%) contrast(200%) hue-rotate(-90deg)',
			}, {
				scale: 1.3,
				filter: 'brightness(100%) contrast(100%) hue-rotate(0deg)',
			}, 0)

		}
		mouseleave() {
			
			if ( this.enterTimeout ) {
				this.enterTimeout.kill();
			}

			this.leaveTimeout = gsap.timeline({
				defaults: {
					duration: 0.5,
					ease: 'power2.inOut',
				},
			})
			.set(this.DOM.bottom, {willChange: 'filter'})
			.set(this.DOM.top, {willChange: 'clip-path'})
			.to(this.DOM.top, {
				clipPath: 'circle(70.7% at 50% 50%)'
			}, 0)

			.to(this.DOM.bottom, {
				filter: 'brightness(0%) contrast(400%)',
				scale: 3.3
			}, 0)

		}
	}
	
	class Fx7 {
		DOM = {
			el: null,
			bottom: null,
			top: null
		}
		constructor(DOM_el) {
			this.DOM.el = DOM_el;
			this.layout();
		}
		layout() {
			
			// get element background-image url
			const url = getComputedStyle(this.DOM.el).backgroundImage.match(/url\(["']?([^"']*)["']?\)/)[1];
			gsap.set(this.DOM.el, {backgroundImage: 'none'});

			const iterations = 2;
			let innerHTML = '';
			for (let i = 0; i < iterations; ++i) {
				innerHTML += `<div class="double__img" style="background-image:url(${url})"></div>`;
			}
			this.DOM.el.innerHTML = innerHTML;

			this.DOM.bottom = this.DOM.el.querySelector('.double__img:first-child');
			this.DOM.top = this.DOM.el.querySelector('.double__img:last-child');
		}
		mouseenter() {

			if ( this.leaveTimeout ) {
				this.leaveTimeout.kill();
			}

			this.enterTimeout = gsap.timeline({
				defaults: {
					duration: 0.8,
					ease: 'expo',
				},
			})
			.set(this.DOM.bottom, {willChange: 'filter', transformOrigin: '50% 50%'})
			.set(this.DOM.top, {willChange: 'clip-path'})
			.fromTo(this.DOM.top, {
				clipPath: 'circle(141.2% at 100% 0%)',
			}, {
				clipPath: 'circle(0% at 100% 0%)'
			}, 0)
			
			.fromTo(this.DOM.bottom, {
				transformOrigin: '50% 100%',
				rotate: 3,
				filter: 'brightness(0%) saturate(600%)',
			}, {
				duration: 0.8,
				filter: 'brightness(100%) saturate(100%)',
				rotate: 0,
				scale: 1.2,
			}, 0)

		}
		mouseleave() {
			
			if ( this.enterTimeout ) {
				this.enterTimeout.kill();
			}

			this.leaveTimeout = gsap.timeline({
				defaults: {
					duration: 0.8,
					ease: 'expo',
				},
			})
			.set(this.DOM.bottom, {willChange: 'filter'})
			.set(this.DOM.top, {willChange: 'clip-path'})
			.to(this.DOM.top, {
				clipPath: 'circle(141.2% at 100% 0%)'
			}, 0)

			.to(this.DOM.bottom, {
				duration: 0.8,
				filter: 'brightness(0%) saturate(200%)',
				scale: 1
			}, 0)

		}
	}
	
	class Fx8 {
		DOM = {
			el: null,
			bottom: null,
			top: null
		}
		constructor(DOM_el) {
			this.DOM.el = DOM_el;
			this.layout();
		}
		layout() {
			
			// get element background-image url
			const url = getComputedStyle(this.DOM.el).backgroundImage.match(/url\(["']?([^"']*)["']?\)/)[1];
			gsap.set(this.DOM.el, {backgroundImage: 'none'});

			const iterations = 3;
			let innerHTML = '';
			for (let i = 0; i < iterations; ++i) {
				innerHTML += `<div class="double__img" style="background-image:url(${url})"></div>`;
			}
			this.DOM.el.innerHTML = innerHTML;

			this.DOM.bottom = this.DOM.el.querySelector('.double__img:first-child');
			this.DOM.middle = this.DOM.el.querySelector('.double__img:nth-child(2)');
			this.DOM.top = this.DOM.el.querySelector('.double__img:last-child');
			
			gsap.set(this.DOM.bottom, {
				scale: 1.3
			});
			gsap.set(this.DOM.middle, {
				scaleX: -1.15,
				scaleY: 1.15,
			});
		}
		mouseenter() {

			if ( this.leaveTimeout ) {
				this.leaveTimeout.kill();
			}

			const DURATION = 0.6;
			this.enterTimeout = gsap.timeline({
				defaults: {
					duration: DURATION/2,
					ease: 'power1',
				},
			})
			.addLabel('start', 0)
			.set([this.DOM.middle,this.DOM.bottom], {willChange: 'filter'})
			.set([this.DOM.middle,this.DOM.top], {willChange: 'clip-path'})
			.fromTo(this.DOM.top, {
				clipPath: 'polygon(0% 0%, 100% 0%, 100% 100%, 0% 100%)',
			}, {
				clipPath: 'polygon(0% 0%, 0% 0%, 0% 100%, 0% 100%)'
			}, 'start')
			.fromTo(this.DOM.middle, {
				filter: 'brightness(600%) saturate(200%)',
			}, {
				filter: 'brightness(100%) saturate(100%)',
			}, 'start')

			.fromTo(this.DOM.middle, {
				clipPath: 'polygon(0% 0%, 100% 0%, 100% 100%, 0% 100%)',
			}, {
				clipPath: 'polygon(0% 0%, 0% 0%, 0% 100%, 0% 100%)'
			}, `start+=${DURATION/2}`)
			
			.fromTo(this.DOM.bottom, {
				filter: 'brightness(600%) saturate(200%)',
			}, {
				filter: 'brightness(100%) saturate(100%)',
			}, `start+=${DURATION/2}`)

		}
		mouseleave() {
			
			if ( this.enterTimeout ) {
				this.enterTimeout.kill();
			}

			const DURATION = 0.6;
			this.leaveTimeout = gsap.timeline({
				defaults: {
					duration: DURATION/2,
					ease: 'power1',
				},
			})
			.addLabel('start', 0)
			.set([this.DOM.middle,this.DOM.bottom], {willChange: 'filter'})
			.set([this.DOM.middle,this.DOM.top], {willChange: 'clip-path'})
			.to(this.DOM.bottom, {
				filter: 'brightness(150%) saturate(150%)',
			}, `start`)
			.to(this.DOM.middle, {
				clipPath: 'polygon(0% 0%, 100% 0%, 100% 100%, 0% 100%)',
			}, `start`)
			.to(this.DOM.middle, {
				filter: 'brightness(150%) saturate(150%)',
			}, `start+=${DURATION/2}`)
			.to(this.DOM.top, {
				clipPath: 'polygon(0% 0%, 100% 0%, 100% 100%, 0% 100%)'
			}, `start+=${DURATION/2}`)

		}
	}
	
	class Fx9 {
		DOM = {
			el: null,
			bottom: null,
			top: null
		}
		constructor(DOM_el) {
			this.DOM.el = DOM_el;
			this.layout();
		}
		layout() {
			
			// get element background-image url
			const url = getComputedStyle(this.DOM.el).backgroundImage.match(/url\(["']?([^"']*)["']?\)/)[1];
			gsap.set(this.DOM.el, {backgroundImage: 'none'});

			const iterations = 2;
			let innerHTML = '';
			for (let i = 0; i < iterations; ++i) {
				innerHTML += `<div class="double__img" style="background-image:url(${url})"></div>`;
			}
			this.DOM.el.innerHTML = innerHTML;

			this.DOM.bottom = this.DOM.el.querySelector('.double__img:first-child');
			this.DOM.top = this.DOM.el.querySelector('.double__img:last-child');
		}
		mouseenter() {

			if ( this.leaveTimeout ) {
				this.leaveTimeout.kill();
			}

			this.enterTimeout = gsap.timeline({
				defaults: {
					duration: 0.8,
					ease: 'power4',
				},
			})
			.set(this.DOM.bottom, {transformOrigin: '50% 50%'})
			.set(this.DOM.top, {willChange: 'clip-path'})
			.fromTo(this.DOM.top, {
				clipPath: 'polygon(0% 0%, 100% 0%, 100% 100%, 0% 100%)',
			}, {
				clipPath: 'polygon(100% 0%, 100% 0%, 0% 100%, 0% 100%)'
			}, 0)
			
			.fromTo(this.DOM.bottom, {
				skewX: 15,
				scale: 2,
				filter: 'brightness(600%)',
			}, {
				skewX: 0,
				scale: 1,
				filter: 'brightness(100%)',
				scale: 1.1,
			}, 0)

		}
		mouseleave() {
			
			if ( this.enterTimeout ) {
				this.enterTimeout.kill();
			}

			this.leaveTimeout = gsap.timeline({
				defaults: {
					duration: 0.8,
					ease: 'power4',
				},
			})
			.set(this.DOM.top, {willChange: 'clip-path'})
			.to(this.DOM.top, {
				clipPath: 'polygon(0% 0%, 100% 0%, 100% 100%, 0% 100%)'
			}, 0)

			.to(this.DOM.bottom, {
				filter: 'brightness(600%)',
				skewX: 15,
				scale: 2,
				onComplete: () => gsap.set(this.DOM.bottom, {
					filter: 'brightness(0%)',
				})
			}, 0)

		}
	}
	
	class Fx10 {
		DOM = {
			el: null,
			bottom: null,
			top: null
		}
		constructor(DOM_el) {
			this.DOM.el = DOM_el;
			this.layout();
		}
		layout() {
			
			// get element background-image url
			const url = getComputedStyle(this.DOM.el).backgroundImage.match(/url\(["']?([^"']*)["']?\)/)[1];
			gsap.set(this.DOM.el, {backgroundImage: 'none'});

			const iterations = 5;
			let innerHTML = '';
			for (let i = 0; i < iterations; ++i) {
				innerHTML += `<div class="double__img" style="background-image:url(${url})"></div>`;
			}
			this.DOM.el.innerHTML = innerHTML;
			this.DOM.images = [...this.DOM.el.querySelectorAll('.double__img')];

			gsap.set(this.DOM.images[0], {
				scale: 1.3,
				filter: 'saturate(200%)'
			})
		}
		mouseenter() {

			if ( this.leaveTimeout ) {
				this.leaveTimeout.kill();
			}

			this.enterTimeout = gsap.timeline({
				defaults: {
					duration: 0.5,
					ease: 'power3',
				},
			})
			.set(this.DOM.images, {willChange: 'clip-path'})
			.fromTo(this.DOM.images[1], {
				clipPath: 'polygon(50% 50%, 100% 50%, 100% 100%, 50% 100%)',
			}, {
				duration: 1,
				ease: 'expo',
				clipPath: 'polygon(100% 50%, 100% 50%, 100% 100%, 100% 100%)'
			}, 0.6)
			.fromTo(this.DOM.images[2], {
				clipPath: 'polygon(0% 50%, 50% 50%, 50% 100%, 0% 100%)',
			}, {
				clipPath: 'polygon(0% 100%, 50% 100%, 50% 100%, 0% 100%)'
			}, 0.4)
			.fromTo(this.DOM.images[3], {
				clipPath: 'polygon(50% 0%, 100% 0%, 100% 50%, 50% 50%)',
			}, {
				clipPath: 'polygon(50% 50%, 100% 50%, 100% 50%, 50% 50%)'
			}, 0)
			.fromTo(this.DOM.images[4], {
				clipPath: 'polygon(0% 0%, 50% 0%, 50% 50%, 0% 50%)',
			}, {
				clipPath: 'polygon(0% 0%, 0% 0%, 0% 50%, 0% 50%)'
			}, 0.2)

		}
		mouseleave() {
			
			if ( this.enterTimeout ) {
				this.enterTimeout.kill();
			}

			this.leaveTimeout = gsap.timeline({
				defaults: {
					duration: 0.4,
					ease: 'power3',
				},
			})
			.set(this.DOM.images, {willChange: 'clip-path'})
			.to(this.DOM.images[1], {
				clipPath: 'polygon(50% 50%, 100% 50%, 100% 100%, 50% 100%)',
			}, 0)
			.to(this.DOM.images[2], {
				clipPath: 'polygon(0% 50%, 50% 50%, 50% 100%, 0% 100%)',
			}, 0.2)
			.to(this.DOM.images[3], {
				clipPath: 'polygon(50% 0%, 100% 0%, 100% 50%, 50% 50%)',
			}, 0.6)
			.to(this.DOM.images[4], {
				clipPath: 'polygon(0% 0%, 50% 0%, 50% 50%, 0% 50%)',
			}, 0.4)

		}
	}
	
	class Fx11 {
		DOM = {
			el: null,
			bottom: null,
			top: null
		}
		constructor(DOM_el) {
			this.DOM.el = DOM_el;
			this.layout();
		}
		layout() {
			
			// get element background-image url
			const url = getComputedStyle(this.DOM.el).backgroundImage.match(/url\(["']?([^"']*)["']?\)/)[1];
			gsap.set(this.DOM.el, {backgroundImage: 'none'});

			const iterations = 5;
			let innerHTML = '';
			for (let i = 0; i < iterations; ++i) {
				innerHTML += `<div class="double__img" style="background-image:url(${url})"></div>`;
			}
			this.DOM.el.innerHTML = innerHTML;
			this.DOM.images = [...this.DOM.el.querySelectorAll('.double__img')];

			gsap.set(this.DOM.images[0], {
				scale: 0.9,
				filter: 'saturate(200%) hue-rotate(90deg)'
			})
		}
		mouseenter() {

			if ( this.leaveTimeout ) {
				this.leaveTimeout.kill();
			}

			this.enterTimeout = gsap.timeline({
				defaults: {
					duration: 0.3,
					ease: 'steps(3)',
				},
			})
			.set(this.DOM.images, {willChange: 'clip-path'})
			.fromTo(this.DOM.images[1], {
				clipPath: 'polygon(50% 50%, 100% 50%, 100% 100%, 50% 100%)',
			}, {
				clipPath: 'polygon(100% 50%, 100% 50%, 100% 100%, 100% 100%)'
			}, 0.4)
			.fromTo(this.DOM.images[2], {
				clipPath: 'polygon(0% 50%, 50% 50%, 50% 100%, 0% 100%)',
			}, {
				clipPath: 'polygon(0% 100%, 50% 100%, 50% 100%, 0% 100%)'
			}, 0.6)
			.fromTo(this.DOM.images[3], {
				clipPath: 'polygon(50% 0%, 100% 0%, 100% 50%, 50% 50%)',
			}, {
				clipPath: 'polygon(50% 50%, 100% 50%, 100% 50%, 50% 50%)'
			}, 0)
			.fromTo(this.DOM.images[4], {
				clipPath: 'polygon(0% 0%, 50% 0%, 50% 50%, 0% 50%)',
			}, {
				clipPath: 'polygon(0% 0%, 0% 0%, 0% 50%, 0% 50%)'
			}, 0.2)

		}
		mouseleave() {
			
			if ( this.enterTimeout ) {
				this.enterTimeout.kill();
			}

			this.leaveTimeout = gsap.timeline({
				defaults: {
					duration: 0.5,
					ease: 'steps(3)',
				},
			})
			.set(this.DOM.images, {willChange: 'clip-path'})
			.to(this.DOM.images[1], {
				clipPath: 'polygon(50% 50%, 100% 50%, 100% 100%, 50% 100%)',
			}, 0)
			.to(this.DOM.images[2], {
				clipPath: 'polygon(0% 50%, 50% 50%, 50% 100%, 0% 100%)',
			}, 0.6)
			.to(this.DOM.images[3], {
				clipPath: 'polygon(50% 0%, 100% 0%, 100% 50%, 50% 50%)',
			}, 0.2)
			.to(this.DOM.images[4], {
				clipPath: 'polygon(0% 0%, 50% 0%, 50% 50%, 0% 50%)',
			}, 0.4)

		}
	}

	class DoubleImageEffect {
		DOM = {
			el: null
		}
		effects = {
			'1': 'Fx1',
			'2': 'Fx2',
			'3': 'Fx3',
			'4': 'Fx4',
			'5': 'Fx5',
			'6': 'Fx6',
			'7': 'Fx7',
			'8': 'Fx8',
			'9': 'Fx9',
			'10': 'Fx10',
			'11': 'Fx11',

		};
		classMap = {Fx1,Fx2,Fx3,Fx4,Fx5,Fx6,Fx7,Fx8,Fx9,Fx10,Fx11};

		constructor(DOM_el) {
			this.DOM.el = DOM_el;
			this.effectName = this.effects[this.DOM.el.dataset.effect] || 'Fx1';
			this.effect = new this.classMap[this.effectName](this.DOM.el);
			this.initEvents();
		}
		initEvents() {
			this.DOM.el.addEventListener('mouseenter', () => { 
				this.effect.mouseenter();
			});

			this.DOM.el.addEventListener('mouseleave', () => {
				this.effect.mouseleave();
			});
		}
	}

	// Lenis smooth scrolling
	let lenis;

	// Initialize Lenis smooth scrolling
	const initSmoothScrolling = () => {
		
		lenis = new Lenis({
			smoothWheel: true
		});

		const scrollFn = (time) => {
			lenis.raf(time);
			requestAnimationFrame(scrollFn);
		};
		
		requestAnimationFrame(scrollFn);

	};

	[...document.querySelectorAll('.double')].forEach(el => new DoubleImageEffect(el));

	// Preload images
	imagesLoaded(document.querySelectorAll('.double__img'), {background: true}, () => {
		// Lenis (smooth scrolling)
		initSmoothScrolling();
	});


})(jQuery);